# pulp_file-client
Fetch, Upload, Organize, and Distribute Software Packages

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: v3
- Package version: 1.2.0.dev01595936126
- Build package: org.openapitools.codegen.languages.PythonClientCodegen
For more information, please visit [https://pulpproject.org](https://pulpproject.org)

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import pulpcore.client.pulp_file
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import pulpcore.client.pulp_file
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function

import time
import pulpcore.client.pulp_file
from pulpcore.client.pulp_file.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://pulp
# See configuration.py for a list of all supported configuration parameters.
configuration = pulpcore.client.pulp_file.Configuration(
    host = "http://pulp"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure HTTP basic authorization: basicAuth
configuration = pulpcore.client.pulp_file.Configuration(
    username = 'YOUR_USERNAME',
    password = 'YOUR_PASSWORD'
)

# Configure API key authorization: cookieAuth
configuration = pulpcore.client.pulp_file.Configuration(
    host = "http://pulp",
    api_key = {
        'Session': 'YOUR_API_KEY'
    }
)
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Session'] = 'Bearer'


# Enter a context with an instance of the API client
with pulpcore.client.pulp_file.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = pulpcore.client.pulp_file.ContentFilesApi(api_client)
    relative_path = 'relative_path_example' # str | Path where the artifact is located relative to distributions base_path
artifact = 'artifact_example' # str | Artifact file representing the physical content (optional)
file = '/path/to/file' # file | An uploaded file that may be turned into the artifact of the content unit. (optional)
repository = 'repository_example' # str | A URI of a repository the new content unit should be associated with. (optional)

    try:
        api_response = api_instance.create(relative_path, artifact=artifact, file=file, repository=repository)
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling ContentFilesApi->create: %s\n" % e)
    
```

## Documentation for API Endpoints

All URIs are relative to *http://pulp*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*ContentFilesApi* | [**create**](docs/ContentFilesApi.md#create) | **POST** /pulp/api/v3/content/file/files/ | 
*ContentFilesApi* | [**list**](docs/ContentFilesApi.md#list) | **GET** /pulp/api/v3/content/file/files/ | 
*ContentFilesApi* | [**read**](docs/ContentFilesApi.md#read) | **GET** {file_content_href} | 
*DistributionsFileApi* | [**create**](docs/DistributionsFileApi.md#create) | **POST** /pulp/api/v3/distributions/file/file/ | 
*DistributionsFileApi* | [**delete**](docs/DistributionsFileApi.md#delete) | **DELETE** {file_distribution_href} | 
*DistributionsFileApi* | [**list**](docs/DistributionsFileApi.md#list) | **GET** /pulp/api/v3/distributions/file/file/ | 
*DistributionsFileApi* | [**partial_update**](docs/DistributionsFileApi.md#partial_update) | **PATCH** {file_distribution_href} | 
*DistributionsFileApi* | [**read**](docs/DistributionsFileApi.md#read) | **GET** {file_distribution_href} | 
*DistributionsFileApi* | [**update**](docs/DistributionsFileApi.md#update) | **PUT** {file_distribution_href} | 
*ExportersFileExportsApi* | [**create**](docs/ExportersFileExportsApi.md#create) | **POST** {export_href}exports/ | 
*ExportersFileExportsApi* | [**delete**](docs/ExportersFileExportsApi.md#delete) | **DELETE** {export_href} | 
*ExportersFileExportsApi* | [**list**](docs/ExportersFileExportsApi.md#list) | **GET** {export_href}exports/ | 
*ExportersFileExportsApi* | [**read**](docs/ExportersFileExportsApi.md#read) | **GET** {export_href} | 
*ExportersFilesystemApi* | [**create**](docs/ExportersFilesystemApi.md#create) | **POST** /pulp/api/v3/exporters/file/filesystem/ | 
*ExportersFilesystemApi* | [**delete**](docs/ExportersFilesystemApi.md#delete) | **DELETE** {file_filesystem_exporter_href} | 
*ExportersFilesystemApi* | [**list**](docs/ExportersFilesystemApi.md#list) | **GET** /pulp/api/v3/exporters/file/filesystem/ | 
*ExportersFilesystemApi* | [**partial_update**](docs/ExportersFilesystemApi.md#partial_update) | **PATCH** {file_filesystem_exporter_href} | 
*ExportersFilesystemApi* | [**read**](docs/ExportersFilesystemApi.md#read) | **GET** {file_filesystem_exporter_href} | 
*ExportersFilesystemApi* | [**update**](docs/ExportersFilesystemApi.md#update) | **PUT** {file_filesystem_exporter_href} | 
*PublicationsFileApi* | [**create**](docs/PublicationsFileApi.md#create) | **POST** /pulp/api/v3/publications/file/file/ | 
*PublicationsFileApi* | [**delete**](docs/PublicationsFileApi.md#delete) | **DELETE** {file_publication_href} | 
*PublicationsFileApi* | [**list**](docs/PublicationsFileApi.md#list) | **GET** /pulp/api/v3/publications/file/file/ | 
*PublicationsFileApi* | [**read**](docs/PublicationsFileApi.md#read) | **GET** {file_publication_href} | 
*RemotesFileApi* | [**create**](docs/RemotesFileApi.md#create) | **POST** /pulp/api/v3/remotes/file/file/ | 
*RemotesFileApi* | [**delete**](docs/RemotesFileApi.md#delete) | **DELETE** {file_remote_href} | 
*RemotesFileApi* | [**list**](docs/RemotesFileApi.md#list) | **GET** /pulp/api/v3/remotes/file/file/ | 
*RemotesFileApi* | [**partial_update**](docs/RemotesFileApi.md#partial_update) | **PATCH** {file_remote_href} | 
*RemotesFileApi* | [**read**](docs/RemotesFileApi.md#read) | **GET** {file_remote_href} | 
*RemotesFileApi* | [**update**](docs/RemotesFileApi.md#update) | **PUT** {file_remote_href} | 
*RepositoriesFileApi* | [**create**](docs/RepositoriesFileApi.md#create) | **POST** /pulp/api/v3/repositories/file/file/ | 
*RepositoriesFileApi* | [**delete**](docs/RepositoriesFileApi.md#delete) | **DELETE** {file_repository_href} | 
*RepositoriesFileApi* | [**list**](docs/RepositoriesFileApi.md#list) | **GET** /pulp/api/v3/repositories/file/file/ | 
*RepositoriesFileApi* | [**modify**](docs/RepositoriesFileApi.md#modify) | **POST** {file_repository_href}modify/ | Modify Repository Content
*RepositoriesFileApi* | [**partial_update**](docs/RepositoriesFileApi.md#partial_update) | **PATCH** {file_repository_href} | 
*RepositoriesFileApi* | [**read**](docs/RepositoriesFileApi.md#read) | **GET** {file_repository_href} | 
*RepositoriesFileApi* | [**sync**](docs/RepositoriesFileApi.md#sync) | **POST** {file_repository_href}sync/ | 
*RepositoriesFileApi* | [**update**](docs/RepositoriesFileApi.md#update) | **PUT** {file_repository_href} | 
*RepositoriesFileVersionsApi* | [**delete**](docs/RepositoriesFileVersionsApi.md#delete) | **DELETE** {file_repository_version_href} | 
*RepositoriesFileVersionsApi* | [**list**](docs/RepositoriesFileVersionsApi.md#list) | **GET** {file_repository_version_href}versions/ | 
*RepositoriesFileVersionsApi* | [**read**](docs/RepositoriesFileVersionsApi.md#read) | **GET** {file_repository_version_href} | 
*RepositoriesFileVersionsApi* | [**repair**](docs/RepositoriesFileVersionsApi.md#repair) | **POST** {file_repository_version_href}repair/ | 


## Documentation For Models

 - [AsyncOperationResponse](docs/AsyncOperationResponse.md)
 - [ContentSummary](docs/ContentSummary.md)
 - [ContentSummaryResponse](docs/ContentSummaryResponse.md)
 - [ExportResponse](docs/ExportResponse.md)
 - [FileFileContent](docs/FileFileContent.md)
 - [FileFileContentResponse](docs/FileFileContentResponse.md)
 - [FileFileDistribution](docs/FileFileDistribution.md)
 - [FileFileDistributionResponse](docs/FileFileDistributionResponse.md)
 - [FileFileFilesystemExporter](docs/FileFileFilesystemExporter.md)
 - [FileFileFilesystemExporterResponse](docs/FileFileFilesystemExporterResponse.md)
 - [FileFilePublication](docs/FileFilePublication.md)
 - [FileFilePublicationResponse](docs/FileFilePublicationResponse.md)
 - [FileFileRemote](docs/FileFileRemote.md)
 - [FileFileRemoteResponse](docs/FileFileRemoteResponse.md)
 - [FileFileRepository](docs/FileFileRepository.md)
 - [FileFileRepositoryResponse](docs/FileFileRepositoryResponse.md)
 - [InlineResponse200](docs/InlineResponse200.md)
 - [InlineResponse2001](docs/InlineResponse2001.md)
 - [InlineResponse2002](docs/InlineResponse2002.md)
 - [InlineResponse2003](docs/InlineResponse2003.md)
 - [InlineResponse2004](docs/InlineResponse2004.md)
 - [InlineResponse2005](docs/InlineResponse2005.md)
 - [InlineResponse2006](docs/InlineResponse2006.md)
 - [InlineResponse2007](docs/InlineResponse2007.md)
 - [PatchedfileFileDistribution](docs/PatchedfileFileDistribution.md)
 - [PatchedfileFileFilesystemExporter](docs/PatchedfileFileFilesystemExporter.md)
 - [PatchedfileFileRemote](docs/PatchedfileFileRemote.md)
 - [PatchedfileFileRepository](docs/PatchedfileFileRepository.md)
 - [PolicyEnum](docs/PolicyEnum.md)
 - [PublicationExport](docs/PublicationExport.md)
 - [RepositoryAddRemoveContent](docs/RepositoryAddRemoveContent.md)
 - [RepositorySyncURL](docs/RepositorySyncURL.md)
 - [RepositoryVersion](docs/RepositoryVersion.md)
 - [RepositoryVersionResponse](docs/RepositoryVersionResponse.md)


## Documentation For Authorization


## basicAuth

- **Type**: HTTP basic authentication


## cookieAuth

- **Type**: API key
- **API key parameter name**: Session
- **Location**: 


## Author

pulp-list@redhat.com


